function newAnim(image,w,h,time)
local animation = {}
local ww = image:getWidth()
local hh = image:getHeight()
local maxframe = ww/w
if ww % w == 0 then
	if hh % h == 0 then
		for x = 0,maxframe - 1 do
			animation[x] = love.graphics.newQuad(x*w,0,w,h,ww,hh)
		end
	end
end
animation.image = image
animation.timeMax = time
animation.time = 0
animation.frame = 0
animation.maxFrame = maxframe
return animation
end

function drawAnim(o,x,y,facex,offx,offy)
	if facex then
	
	else
		facex = 1
	end
	if offx then
	
	else
		offx = 0
	end
	if offy then
	
	else
		offy = 0
	end
	local r, g, b, a = love.graphics.getColor( )
	love.graphics.setColor(1,1,1)
	love.graphics.draw(o.image,o[o.frame],math.floor(x),math.floor(y),0,facex,1,offx,offy)
	love.graphics.setColor(r,g,b,a)
end

function updateAnim(o,dt)
	if o.maxFrame ~= 1 then
		o.time = o.time + dt
		if o.time > o.timeMax/o.maxFrame then
			o.time = 0
			o.frame = o.frame + 1
			if o.frame >= o.maxFrame then
				o.frame = 0
			end
		end
	end
end

function effectDraw() -- Draws the particles
	for i,o in pairs(effects) do
		if o.type < 0 then
			love.graphics.setColor(138/255,43/255,226/255) -- Purple for bad
		elseif o.type > 0 then
			love.graphics.setColor(50/255,205/255,50/255) -- Green for good
		elseif o.type == 0 then
			love.graphics.setColor(197/255,179/255,88/255) -- Gold for a winning player/golden cracker
		end
		love.graphics.rectangle("fill",o.x,o.y,6,6)
	end
end

function effectSpawn(x,y,type)
	dirx = math.random(-1000,1000)/1000 -- Chooses particle direction
	diry = math.random(-1000,1000)/1000
	table.insert(effects,{x=x,y=y,type=type,speed=200,dirx=dirx,diry=diry}) -- Makes particles
end

function effectUpdate(dt)
	for i,o in pairs(effects) do
		o.speed = o.speed - 5
		o.x = o.x + o.dirx * dt * o.speed -- Moving Particles
		o.y = o.y + o.diry * dt * o.speed
		if o.speed <= 0 then
			table.remove(effects,i)
		end
	end
end