function checkTile(type,x,y,w,h) -- Checks what tile a player or cracker is on
	local x1 = math.floor(x / cellSize)
	local y1 = math.floor((y - offsetY) / cellSize)
	local x4 = math.floor((x + w) / cellSize)
	local y4 = math.floor((y + h - offsetY) / cellSize)
	local x2 = x4
	local y2 = y1
	local x3 = x1
	local y3 = y4
	if x > 0 then -- Checks if on the grid
		if x + w < 1920 then
			if grid[x1][y1] == type then
				if checkCollision(x,y,w,h,x1*cellSize,y1*cellSize+offsetY,cellSize,cellSize) then
					return true
				end
			end
			if grid[x2][y2] == type then
				if checkCollision(x,y,w,h,x2*cellSize,y2*cellSize+offsetY,cellSize,cellSize) then
					return true
				end
			end
			if grid[x3][y3] == type then
				if checkCollision(x,y,w,h,x3*cellSize,y3*cellSize+offsetY,cellSize,cellSize) then
					return true
				end
			end
			if grid[x4][y4] == type then
				if checkCollision(x,y,w,h,x4*cellSize,y4*cellSize+offsetY,cellSize,cellSize) then
					return true
				end
			end
		end
	end
	return false
end

function checkSurface(x,y,w,h)
	local x1 = math.floor(x / cellSize)
	local y1 = math.floor((y - offsetY) / cellSize)
	local x4 = math.floor((x + w) / cellSize)
	local y4 = math.floor((y + h - offsetY) / cellSize)
	local x2 = x4
	local y2 = y1
	local x3 = x1
	local y3 = y4
	local surface = {}
	if x > 0 then -- Checks if on the grid
		if x + w < 1920 then
			surface[1] = math.max(0, math.min(x+w, x1*cellSize+cellSize) - math.max(x,x1*cellSize)) * math.max(0, math.min(y+h,y1*cellSize+offsetY+cellSize) - math.max(y,y1*cellSize+offsetY))
			surface[2] = math.max(0, math.min(x+w, x2*cellSize+cellSize) - math.max(x,x2*cellSize)) * math.max(0, math.min(y+h,y2*cellSize+offsetY+cellSize) - math.max(y,y2*cellSize+offsetY))
			surface[3] = math.max(0, math.min(x+w, x3*cellSize+cellSize) - math.max(x,x3*cellSize)) * math.max(0, math.min(y+h,y3*cellSize+offsetY+cellSize) - math.max(y,y3*cellSize+offsetY))
			surface[4] = math.max(0, math.min(x+w, x4*cellSize+cellSize) - math.max(x,x4*cellSize)) * math.max(0, math.min(y+h,y4*cellSize+offsetY+cellSize) - math.max(y,y4*cellSize+offsetY))
			local tile = grid[x1][y1]
			local tiletile = surface[1]
			if surface[2] > tiletile then
				tile = grid[x2][y2]
				tiletile = surface[2]
			end
			if surface[3] > tiletile then
				tile = grid[x3][y3]
				tiletile = surface[3]
			end
			if surface[4] > tiletile then
				tile = grid[x4][y4]
				tiletile = surface[4]
			end
			return tile
		end
	end
	return false
end

function checkCollision(x1,y1,w1,h1,x2,y2,w2,h2) -- Normal collision
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end

function menuCollision(x1,y1,w1,h1,x2,y2,w2,h2) -- Normal collision
  return (x1)*screenx/1920 < x2+w2 and
         x2 < (x1+w1)*screenx/1920 and
         (y1)*screeny/1080 < y2+h2 and
         y2 < (y1+h1)*screeny/1080 
end

function checkScreen(x,y,w,h) -- Screen collision
	if x < 0 then
		return true
	end
	if y < offsetY then
		return true
	end
	if x+w > 1920 then
		return true
	end
	if y+h > 1080-offsetY then
		return true
	end
	return false
end