function crackerDraw() -- Draws crackers
	for i,p in pairs(crackers) do
		drawAnim(p.anim,p.x,p.y)
		if hitboxes == true then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",p.x,p.y,p.w,p.h)
		end
	end
end

function crackerSpawn() -- Creating a cracker
	local x=math.random(0,gridXCount-1) -- Chooses a non-wall or trap location
	local y=math.random(0,gridYCount-1)
	while grid[x][y] == 0 or grid[x][y] == 4 do
		x=math.random(0,gridXCount-1)
		y=math.random(0,gridYCount-1)
	end
	local w = 36
	local h = 27
	x = x * cellSize + cellSize/2 - w/2 -- Position
	y = y * cellSize + cellSize/2 + offsetY - h/2
	local type = math.random(1,10)
	if powerups == true then
		if type <= 3 then -- Item type
			local posneg = math.random(-1,1)
			while posneg == 0 do
				posneg = math.random(-1,1)
			end
			type = type * posneg
		else
			type = 0
		end
	else
		type = 0
	end
	if gamemode ~= "quack attack" then
		table.insert(crackers,{type=type,count=crackermovetime,x=x,y=y,w=w,h=h,dirx=0,diry=0,speed=200,anim = newAnim(love.graphics.newImage("items/cracker.png"),w,h,0.2)})
	end
end

function crackerUpdate(dt)
	for i,o in pairs(players) do
		for i,p in pairs(crackers) do
			if checkCollision(o.x,o.y,o.w,o.h,p.x,p.y,p.w,p.h) then -- Points for pickiung up cracker
				if gamemode ~= "golden cracker" then
					o.crackers = o.crackers+1
					o.item = p.type
					crackerSpawn()
					if hydra == true then
						crackerSpawn()
					end
				else
					golden = o.player
				end
				table.remove(crackers,i) -- Spawning new crackers
			end
		end
	end
	for i,o in pairs(crackers) do -- If quacked
		local surface = 0.9
		if checkSurface(o.x,o.y,o.w,o.h) == 2 then -- Checks to see if on sand
			surface = 0.8
		elseif checkSurface(o.x,o.y,o.w,o.h) == 3 then  -- Checks to see if on ice
			surface = 0.97
		end
		if checkTile(4,o.x+ o.dirx * dt * o.speed,o.y,o.w,o.h) then  -- Checks wall collision
			if bouncy == true then
				o.dirx = o.dirx*-1
			else
				o.dirx = 0
			end
		end
		if checkTile(4,o.x,o.y+ o.diry * dt * o.speed,o.w,o.h) then
			if bouncy == true then
				o.diry = o.diry*-1
			else
				o.diry = 0
			end
		end
		if screen == "wall" then
			if checkScreen(o.x+ o.dirx * dt * o.speed,o.y,o.w,o.h) then
				o.dirx = 0
			end
			if checkScreen(o.x,o.y+ o.diry * dt * o.speed,o.w,o.h) then
				o.diry = 0
			end
		elseif screen == "loop" then
			if o.x+o.w < 0 then
				o.x = 1920
			end
			if o.y+o.h < 0 then
				o.y = 1080
			end
			if o.x > 1920 then
				o.x = 0 - o.w
			end
			if o.y > 1080 then
				o.y = 0 - o.h
			end
		end
		o.x = o.x + o.dirx * dt * o.speed -- Moving Crackers (due to quacks)
		o.y = o.y + o.diry * dt * o.speed
		if friction == true then
			o.dirx = o.dirx * surface -- Reducing Velocity
			o.diry = o.diry * surface
		end
		o.count = o.count - dt
		if crackermove == true then
			if o.count <= 0 then -- Spawns new cracker after 10 seconds
				crackerSpawn()
				table.remove(crackers,i)
			end
		end
		if gamemode == "golden cracker" then
			effectSpawn(o.x+o.w/2,o.y+o.h/2,0)
		else
			if o.type ~= 0 then -- Particle effects for item crackers
				effectSpawn(o.x+o.w/2,o.y+o.h/2,o.type)
			end
		end
	end
end