function gameStart(level,speed,p1,p2)
	small = love.graphics.newFont("slkscr.ttf",10)
	big = love.graphics.newFont("slkscr.ttf",120)
	math.randomseed(os.time(sec)*os.time(min))
	players = {} -- Creating the players
	crackers = {}
	grid = {}
	gridimage = {}
	effects = {}
	gridXCount = 30
	gridYCount = 16
	gamespeed = speed
	cellSize = 64
	for x = 0,gridXCount-1 do -- The grid 
		grid[x] = {}
		gridimage[x] = {}
		for y = 0,gridYCount-1 do
			grid[x][y] = 0
			gridimage[x][y] = 0
		end
	end
	levelSpawn(level)
	playerSpawn(1,p1) -- Creating the game
	playerSpawn(2,p2)
	crackerSpawn()
end


randomLevels = { -- Level list
	"basic",
	"ice",
	"desert",
	"maze"
}

function levelSpawn(level) -- Creating a level
	
	if level == nil then -- Choose random level if none is suplied
		level = randomLevels[math.random(1,#randomLevels)]
	end
	
	if level == "random" then
		level = randomLevels[math.random(1,#randomLevels)]
	end
	
	local image = love.image.newImageData("levels/"..level..".png") -- Checking the level
	offsetY = (1080 - cellSize * 16)/2 -- Creating the offset
	
	for x = 0, gridXCount-1 do -- Actual making the level
		for y = 0, gridYCount-1 do
			local r, g, b, a = image:getPixel(x,y) -- Looking at the pxels in the picture to make the level
			
			grid[x][y] = getTile(r,g,b)
			
			if grid[x][y] == 1 then
				local q = math.random(1,3)
				gridimage[x][y] = newAnim(love.graphics.newImage("tiles/1"..q..".png"),64,64,1)
			elseif grid[x][y] == 3 then
				local q = math.random(1,2)
				gridimage[x][y] = newAnim(love.graphics.newImage("tiles/3"..q..".png"),64,64,1)
			else
				local q = grid[x][y]
				gridimage[x][y] = newAnim(love.graphics.newImage("tiles/"..q..".png"),64,64,1)
			end
			
		end
	end
end

function getTile(r,g,b) -- Add more tiles and replace water with other hazard
	if r == 0 and g == 1 and b == 0 then -- Grass Tile
		return 1
	elseif r == 0 and g == 0 and b == 1 then -- Water/Death tile
		return 0
	elseif r == 1 and g == 0 and b == 0 then -- Sand tile
		return 2
	elseif r == 1 and g == 1 and b == 1 then -- Ice tile
		return 3
	elseif r == 0 and g ==0 and b == 0 then -- Wall
		return 4
	end
end

function levelDraw() -- Drawing the level
	for x = 0, gridXCount-1 do
		for y = 0, gridYCount-1 do
			drawAnim(gridimage[x][y],x*cellSize,y*cellSize+offsetY)
			if griddraw == true then
				love.graphics.setColor(0,0,0)
				love.graphics.rectangle("line",x*cellSize,y*cellSize+offsetY,cellSize,cellSize)
			end
		end
	end
end

function levelUpdate(dt)
	for x = 0, gridXCount-1 do
		for y = 0, gridYCount-1 do
			updateAnim(gridimage[x][y],dt)
		end
	end
end

function gameUpdate(dt)
	for x = 1,gamespeed do
		playerUpdate(dt) -- Player
		levelUpdate(dt) -- Tile animations
		crackerUpdate(dt) -- Crackers
		effectUpdate(dt) -- Particles
		winUpdate(dt) -- Checks to see the winner
	end
end

function gameDraw()
	levelDraw()
	if effecteffect == true then
		effectDraw()
	end
	crackerDraw()
	playerDraw()
	if gamemode == "time rush" then
		local button = love.graphics.newText(love.graphics.getFont(),math.floor(wintime))
		local off = button:getWidth()
		love.graphics.print(math.floor(wintime),(1920-off)/2,10)
	end
	love.graphics.setFont(small) -- Changing font for stats
	local msg = "Current FPS: "..tostring(love.timer.getFPS())
	love.graphics.print(msg, 1920-200, 10)
	love.graphics.print(gamespeed, 1920-400, 10)
end