function playerSpawn(player,control)
	local x=math.random(0,gridXCount-1) -- Position
	local y=math.random(0,gridYCount-1)
	while grid[x][y] == 0 or grid[x][y] == 4 do
		x=math.random(0,gridXCount-1)
		y=math.random(0,gridYCount-1)
	end
	local w = 63
	local h = 63
	x = x * cellSize + cellSize/2 - w/2
	y = y * cellSize + cellSize/2 + offsetY - h/2
	if gamemode ~= "quack attack" then
		table.insert(players,{joined = true, stun = 0,x = x,crown = newAnim(love.graphics.newImage("player/crown.png"),21,21,0.3), y = y, dirx = 0, diry = 0, crackers = 0, health = 3, player = player, item = 0, quacktime = 0,w=w,h=h,facex = 1,anim = newAnim(love.graphics.newImage("player/player"..player..".png"),w,h,0.2)})
		applyControl(player,control) -- Character controls
	else
		table.insert(players,{joined = true, stun = 0,x = x,crown = newAnim(love.graphics.newImage("player/crown.png"),21,21,0.3), y = y, dirx = 0, diry = 0, crackers = 0, health = 3, player = player, item = 1, quacktime = 0,w=w,h=h,facex = 1,anim = newAnim(love.graphics.newImage("player/player"..player..".png"),w,h,0.2)})
		applyControl(player,control) -- Character controls
	end
end

function playerUpdate(dt)
	local maxscore = 0
	for i,o in pairs(players) do -- Player Identification
		if gamemode == "golden cracker" then
			if o.player == golden then
				goldtime = goldtime - dt
				if goldtime <= 0 then
					goldtime = goldmax
					o.crackers = o.crackers + 1
				end
			end
		end
		o.stun = o.stun - dt
		if o.player > 4 then
			table.remove(players,i)
		end
		if o.player < 1 then
			table.remove(players,i)
		end
		local controlcontrol = {}
		item()
		local move = false
		o.quacktime = o.quacktime - dt
		for x = 1,5 do
			controlcontrol[x] = string.sub(o.control,x,x)
			if controlcontrol[x] == "!" then
				controlcontrol[x] = "up"
			elseif controlcontrol[x] == "@" then
				controlcontrol[x] = "left"
			elseif controlcontrol[x] == "#" then
				controlcontrol[x] = "down"
			elseif controlcontrol[x] == "$" then
				controlcontrol[x] = "right"
			end
		end
		if o.stun <= 0 then
			if love.keyboard.isDown(controlcontrol[1]) then -- Moving the players
				o.diry = o.diry - 0.25 -- Adding velocity
				move = true -- Saying it has moved, so the running animation can update
			end
			if love.keyboard.isDown(controlcontrol[2]) then
				o.dirx = o.dirx - 0.25
				move = true
			end
			if love.keyboard.isDown(controlcontrol[3]) then
				o.diry = o.diry + 0.25
				move = true
			end
			if love.keyboard.isDown(controlcontrol[4]) then
				o.dirx = o.dirx + 0.25
				move = true
			end
		end
		if o.dirx < 0 then -- Which way the player is facing
			o.facex = -1
		elseif o.dirx > 0 then
			o.facex = 1
		end
		local surface = 0.9
		if checkSurface(o.x,o.y,o.w,o.h) == 2 then -- Checks to see if on sand
			surface = 0.8
		elseif checkSurface(o.x,o.y,o.w,o.h) == 3 then  -- Checks to see if on ice
			surface = 0.97
		end
		if checkTile(4,o.x+ o.dirx * dt * o.speed,o.y,o.w,o.h) then  -- Checks wall collision
			if bouncy == true then
				o.dirx = o.dirx*-1
			else
				o.dirx = 0
			end
		end
		if checkTile(4,o.x,o.y+ o.diry * dt * o.speed,o.w,o.h) then
			if bouncy == true then
				o.diry = o.diry*-1
			else
				o.diry = 0
			end
		end
		if checkTile(4,o.x+ o.dirx * dt * o.speed,o.y+ o.diry * dt * o.speed,o.w,o.h) then
			if bouncy == true then
				o.diry = o.diry*-1
				o.dirx = o.dirx*-1
			else
				o.diry = 0
				o.dirx = 0
			end
		end
		if screen == "wall" then
			if checkScreen(o.x+ o.dirx * dt * o.speed,o.y,o.w,o.h) then
				if bouncy == true then
					o.dirx = o.dirx*-1
				else
					o.dirx = 0
				end
			end
			if checkScreen(o.x,o.y+ o.diry * dt * o.speed,o.w,o.h) then
				if bouncy == true then
					o.diry = o.diry*-1
				else
					o.diry = 0
				end
			end
		elseif screen == "loop" then
			if o.x+o.w < 0 then
				o.x = 1920
			end
			if o.y+o.h < 0 then
				o.y = 1080
			end
			if o.x > 1920 then
				o.x = 0 - o.w
			end
			if o.y > 1080 then
				o.y = 0 - o.h
			end
		end
		if move == true then -- The walk animation
			updateAnim(o.anim,dt)
		end
		updateAnim(o.crown,dt)
		o.x = o.x + o.dirx * dt * o.speed -- Moving Players
		o.y = o.y + o.diry * dt * o.speed
		if friction then
			o.dirx = o.dirx * surface -- Reducing Velocity
			o.diry = o.diry * surface
		end
		if gamemode ~= "quack attack" then
			if o.item ~= 0 then
				effectSpawn(o.x+o.w/2,o.y+o.h/2,o.item)
			end
		end
		if o.crackers > maxscore then
			maxscore = o.crackers
		end
		if o.stun <= 0 then
			if love.keyboard.isDown(controlcontrol[5]) and o.quacktime <= 0 then -- Time reload for quack attack
				o.quacktime = o.quacktimeMax
				quack(o.player)
			end
		end
	end
	if gamemode ~= "golden cracker" then
		for i,o in pairs(players) do
			if o.crackers == maxscore then
				effectSpawn(o.x+o.w/2,o.y+o.h/2,0)
			end
		end
	else
		for i,o in pairs(players) do
			if o.player == golden then
				effectSpawn(o.x+o.w/2,o.y+o.h/2,0)
			end
		end
	end
end
function applyControl(player,control) -- Changing the player controls (possibly change for individual button changing)
	local works = false
	for i,o in pairs(players) do
		if o.player == player then
			works = true
		end
	end
	if works == false then
		print("Player "..player.." is not connected or allowed")
		return
	end
	for i,o in pairs(players) do
		if o.player == player then
			o.control = control
		end
	end
end

function playerDraw() -- Drawing the players (currently dots)
	local x = {}
	local y = {}
	local facex = {}
	local w = {}
	local h = {}
	local anim = {}
	local crown = {}
	local maxscore = 0
	for i,o in ipairs(players) do -- Getting stats for drawing
		if o.joined == true then
			x[o.player] = o.x
			y[o.player] = o.y
			facex[o.player] = o.facex
			h[o.player] = o.h
			w[o.player] = o.w
			anim[o.player] = o.anim
			if gamemode ~= "golden cracker" then
				crown[o.player] = o.crown
			else
				if o.player == golden then
					crown[o.player] = o.crown
				end
			end
			if o.crackers > maxscore then
				maxscore = o.crackers
			end
		end
	end
	if gamemode ~= "golden cracker" then
		for i,o in ipairs(players) do
			if o.crackers ~= maxscore then
				crown[o.player] = nil
			end
		end
	end
	local offsetX = 18
	if y[2]+h[2] < y[1]+h[1] then -- Drawing players on a z axis
		drawAnim(anim[2],x[2]+w[2]/2,y[2]+h[2]/2,facex[2],w[2]/2,h[2]/2)
		if crown[2] then
			local a = offsetX * facex[2]*1
			drawAnim(crown[2],x[2]+w[2]/2-a,y[2]+12,facex[2]*-1,w[2]/2,h[2]/2)
		end
		drawAnim(anim[1],x[1]+w[1]/2,y[1]+h[1]/2,facex[1],w[1]/2,h[1]/2)
		if crown[1] then
			local a = offsetX * facex[1]*1
			drawAnim(crown[1],x[1]+w[1]/2-a,y[1]+12,facex[1]*-1,w[1]/2,h[1]/2)
		end
		if hitboxes == true then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",x[1],y[1],w[1],h[1])
			love.graphics.rectangle("line",x[2],y[2],w[2],h[2])
		end
	else
		drawAnim(anim[1],x[1]+w[1]/2,y[1]+h[1]/2,facex[1],w[1]/2,h[1]/2)
		if crown[1] then
			local a = offsetX * facex[1]*1
			drawAnim(crown[1],x[1]+w[1]/2-a,y[1]+12,facex[1]*-1,w[1]/2,h[1]/2)
		end
		drawAnim(anim[2],x[2]+w[2]/2,y[2]+h[2]/2,facex[2],w[2]/2,h[2]/2)
		if crown[2] then
			local a = offsetX * facex[2]*1
			drawAnim(crown[2],x[2]+w[2]/2-a,y[2]+12,facex[2]*-1,w[2]/2,h[2]/2)
		end
		if hitboxes == true then
			love.graphics.setColor(0,0,0)
			love.graphics.rectangle("line",x[1],y[1],w[1],h[1])
			love.graphics.rectangle("line",x[2],y[2],w[2],h[2])
		end
	end
	love.graphics.setFont(big)
	for i,o in pairs(players) do -- Printing score
		love.graphics.setColor(1,1,1)
		if o.player == 1 then
			love.graphics.print(o.crackers,10,10)
		elseif o.player == 2 then
			local text = love.graphics.newText(love.graphics.getFont(), tostring(o.crackers)) -- What offset to draw the player's stats
			local off = text:getWidth()
			love.graphics.print(o.crackers	,1920-10-off,10)
		end
	end
end

function quack(player) -- Quack Attack (player says which person is attacking)
	local x,y,range
	local quacked = false
	for i,o in pairs(players) do -- Makes sure knockback isn't applied to the player using the attack
		if o.player == player then
			x,y,range = o.x,o.y,o.range
		end
	end
	for i,o in pairs(players) do 
		if o.player ~= player then
			local angle = math.atan2((y - o.y), (x - o.x)) -- The actual knockback
			local rangex = x - o.x
			local rangey = y - o.y
			local distance = math.sqrt((rangex)^2+(rangey)^2)
			distance = (distance-range)/25
			if distance >= 0 then
				distance = 0
			elseif gamemode == "golden cracker" then
				if o.player == golden then
					golden = player
				end
			end
			print(distance)
			o.dirx = o.dirx + distance * math.cos(angle)
			o.diry = o.diry + distance * math.sin(angle)
			if distance ~= 0 then
				o.stun = 0.3
				if gamemode == "quack attack" then
					quacked = true
					o.stun = 0.5
				end
			end
		end
	end
	for i,o in pairs(crackers) do -- Cracker knockback
		local angle = math.atan2((y - o.y), (x - o.x)) -- The actual knockback
		local rangex = x - o.x
		local rangey = y - o.y
		local distance = math.sqrt(rangex^2+rangey^2)
		distance = (distance-range)/25
		if distance >= 0 then
			distance = 0
		end
		print (distance)
		o.dirx = o.dirx + distance * math.cos(angle)
		o.diry = o.diry + distance * math.sin(angle)
	end
	if gamemode == "quack attack" then
		if quacked == true then
			for i,o in pairs(players) do -- Makes sure knockback isn't applied to the player using the attack
				if o.player == player then
					o.crackers = o.crackers + 1
				end
			end
		end
	end
end

function item() -- Checking what item a player has and changing stats on it
	for i,o in pairs(players) do
		if o.item == 1 then -- Range bonus/minus
			o.range = 300
		elseif o.item == -1 then
			o.range = 100
		else
			o.range = 200
		end
		if o.item == 2 then -- Cooldown reduction/addition
			o.quacktimeMax = 2
		elseif o.item == -2 then
			o.quacktimeMax = 4
		else
			o.quacktimeMax = 3
		end
		if o.item == 3 then -- Speed bonus/minus
			o.speed = 300
		elseif o.item == -2 then
			o.speed = 100
		else
			o.speed = 200
		end
	end
end